import config
import random
from decorators import log_time

def get_user_choice():
    user_input = input('Enter your choice (r, s, p): ')
    if user_input not in config.GAME_CHOICES:
        print('Please Enter Again.....')
        return get_user_choice()
    return user_input


def get_system_choice():
    return random.choice(config.GAME_CHOICES)


def find_winner(user, system):
    match = {user, system}
    if len(match) == 1:
        return None
    return config.RULS[tuple(sorted(match ))]


def update_scoreboard(result):
    if result['user'] == 3:
        config.score_board['user'] += 1
    else:
        config.score_board['system'] += 1

    print(f'user: {config.score_board["user"]}')
    print(f'system: {config.score_board["system"]}')


def play_one():
    result = {'user': 0, 'system': 0}

    while result['user'] < 3 and result['system'] < 3:
        user_choice = get_user_choice()
        system_choice = get_system_choice()
        winner = find_winner(user_choice, system_choice)
        if winner == user_choice:
            msg = "you win..."
            result['user'] += 1
        elif winner == system_choice:
            msg = "you lose..."
            result['system'] += 1
        else:
            msg = "Drow......"

        print(f"user: {user_choice}")
        print(f"system: {system_choice}")
        print(f"result: {msg}")

    update_scoreboard(result)

    play_again= input("Do you want to play again? (y/n): ")
    if play_again == 'y':
        play_one()

@log_time
def play():
    play_one()

if __name__ == '__main__':
    play()

